﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Remoting.Channels;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamMenuNotResponsive
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        //contains only the MenuTitles
        List<string> allSubItems = new List<string>();
        //contains all DataItems
        List<MyDataItem> myAllDataItems = new List<MyDataItem>();
        XamMenuItem parentRootItem = new XamMenuItem();
        public MainWindow()
        {
            this.DataContext = new ViewModel();
            InitializeComponent();
        }
        private void XamMenuItem_SubmenuOpened(object sender, EventArgs e)
        {
            parentRootItem = (sender as XamMenuItem);
        }
        private void UIElement_OnMouseEnter(object sender, MouseEventArgs e)
        {
            XamMenuItem xamMenuItem = sender as XamMenuItem;
            if (xamMenuItem != null)
                myAllDataItems.Add(parentRootItem.Items.Cast<MyDataItem>().ToList().FirstOrDefault(itm => itm.MenuTitle == xamMenuItem.Header.ToString()));

            GetDataSubItems(myAllDataItems);

            StringBuilder str = new StringBuilder();
            foreach (var element in allSubItems)
                str.AppendLine(element.ToString());
            MessageBox.Show(str.ToString());

            allSubItems = new List<string>();
            myAllDataItems = new List<MyDataItem>();
        }
        public void GetDataSubItems(List<MyDataItem> parentItem)
        {
            foreach (MyDataItem item in parentItem)
            {
                allSubItems.Add(item.MenuTitle.ToString());
                if (item.Children.Count > 0)
                {
                    GetDataSubItems(((MyDataItem)item).Children);
                }
            }
        }
    }
}
